


NAMED.CONF(5)             FreeBSD File Formats Manual            NAMED.CONF(5)

NNAAMMEE
     nnaammeedd..ccoonnff - configuration file for named(8)


OOVVEERRVVIIEEWW
     BIND 8 is much more configurable than previous release of BIND.  There
     are entirely new areas of configuration, such as access control lists and
     categorized logging.  Many options that previously applied to all zones
     can now be used selectively.  These features, plus a consideration of fu-
     ture configuration needs led to the creation of a new configuration file
     format.


   GGeenneerraall SSyynnttaaxx

     A BIND 8 configuration consists of two general features, statements and
     comments.  All statements end with a semicolon.  Many statements can con-
     tain substatements, which are each also terminated with a semicolon.


     The following statements are supported:

     llooggggiinngg
       specifies what the server logs, and where the log messages are sent


     ooppttiioonnss
       controls global server configuration options and sets defaults for oth-
       er statements


     zzoonnee
       defines a zone


     aaccll
       defines a named IP address matching list, for access control and other
       uses


     kkeeyy
       specifies key information for use in authentication and authorization


     ttrruusstteedd--kkeeyyss
       defines DNSSEC keys that are preconfigured into the server and implic-
       itly trusted


     sseerrvveerr
       sets certain configuration options for individual remote servers


     ccoonnttrroollss
       declares control channels to be used by the nnddcc utility


     iinncclluuddee
       includes another file


     The llooggggiinngg and ooppttiioonnss statements may only occur once per configuration,
     while the rest may appear numerous times.  Further detail on each state-
     ment is provided in individual sections below.

     Comments may appear anywhere that whitespace may appear in a BIND config-
     uration file.  To appeal to programmers of all kinds, they can be written
     in C, C++, or shell/perl constructs.

     C-style comments start with the two characters /* (slash, star) and end
     with */ (star, slash).  Because they are completely delimited with these
     characters, they can be used to comment only a portion of a line or to
     span multiple lines.

     C-style comments cannot be nested.  For example, the following is not
     valid because the entire comment ends with the first */:


           /* This is the start of a comment.
              This is still part of the comment.
           /* This is an incorrect attempt at nesting a comment. */
              This is no longer in any comment. */

     C++-style comments start with the two characters // (slash, slash) and
     continue to the end of the physical line.  They cannot be continued
     across multiple physical lines; to have one logical comment span multiple
     lines, each line must use the // pair.  For example:


           // This is the start of a comment.  The next line
           // is a new comment, even though it is logically
           // part of the previous comment.

     Shell-style (or perl-style, if you prefer) comments start with the char-
     acter # (hash or pound or number or octothorpe or whatever) and continue
     to the end of the physical line, like C++ comments.  For example:


           # This is the start of a comment.  The next line
           # is a new comment, even though it is logically
           # part of the previous comment.

     _W_A_R_N_I_N_G_: you cannot use the ; (semicolon) character to start a comment
     such as you would in a zone file.  The semicolon indicates the end of a
     configuration statement, so whatever follows it will be interpreted as
     the start of the next statement.


   CCoonnvveerrttiinngg ffrroomm BBIINNDD 44..99..xx


     BIND 4.9.x configuration files can be converted to the new format by us-
     ing _s_r_c_/_b_i_n_/_n_a_m_e_d_/_n_a_m_e_d_-_b_o_o_t_c_o_n_f, a shell script that is part of the BIND
     8.2.x source kit.


DDOOCCUUMMEENNTTAATTIIOONN DDEEFFIINNIITTIIOONNSS
     Described below are elements used throughout the BIND configuration file
     documentation.  Elements which are only associated with one statement are
     described only in the section describing that statement.


     _a_c_l___n_a_m_e
       The name of an _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t as defined by the aaccll statement.



     _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t
       A list of one or more _i_p___a_d_d_r, _i_p___p_r_e_f_i_x, _k_e_y___i_d, or _a_c_l___n_a_m_e elements,
       as described in the _A_D_D_R_E_S_S _M_A_T_C_H _L_I_S_T_S section.


     _d_o_t_t_e_d_-_d_e_c_i_m_a_l
       One or more integers valued 0 through 255 separated only by dots
       (``.''), such as 123, 45.67 or 89.123.45.67.


     _d_o_m_a_i_n___n_a_m_e
       A quoted string which will be used as a DNS name, for example
       "my.test.domain".


     _p_a_t_h___n_a_m_e
       A quoted string which will be used as a pathname, such as
       "zones/master/my.test.domain".


     _i_p___a_d_d_r
       An IP address in with exactly four elements in _d_o_t_t_e_d_-_d_e_c_i_m_a_l notation.


     _i_p___p_o_r_t
       An IP port _n_u_m_b_e_r. _n_u_m_b_e_r _i_s _l_i_m_i_t_e_d _t_o 0 through 65535, with values
       below 1024 typically restricted to root-owned processes.  In some cases
       an asterisk (``*'') character can be used as a placeholder to select a
       random high-numbered port.


     _i_p___p_r_e_f_i_x
       An IP network specified in _d_o_t_t_e_d_-_d_e_c_i_m_a_l form, followed by  ``/'' and
       then the number of bits in the netmask.  E.g.  127/8 is the network
       127.0.0.0 with netmask 255.0.0.0. 1.2.3.0/28 is network 1.2.3.0 with
       netmask 255.255.255.240.


     _k_e_y___n_a_m_e
       A string representing the name of a shared key, to be used for transac-
       tion security.


     _n_u_m_b_e_r
       A non-negative integer with an entire range limited by the range of a C
       language signed integer (2,147,483,647 on a machine with 32 bit inte-
       gers).  Its acceptable value might further be limited by the context in
       which it is used.


     _s_i_z_e___s_p_e_c
       A _n_u_m_b_e_r, the word unlimited, or the word default.


       The maximum value of _s_i_z_e___s_p_e_c is that of unsigned long integers on the
       machine.  unlimited requests unlimited use, or the maximum available
       amount.  default uses the limit that was in force when the server was
       started.


       A _n_u_m_b_e_r can optionally be followed by a scaling factor: K or k for
       kilobytes, M or m for megabytes, and G or g for gigabytes, which scale
       by 1024, 1024*1024, and 1024*1024*1024 respectively.



       Integer storage overflow is currently silently ignored during conver-
       sion of scaled values, resulting in values less than intended, possibly
       even negative.  Using unlimited is the best way to safely set a really
       large number.


     _y_e_s___o_r___n_o
       Either yes or no. The words true and false are also accepted, as are
       the numbers 1 and 0.



AADDDDRREESSSS MMAATTCCHH LLIISSTTSS
   SSyynnttaaxx


     _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t    = 1*_a_d_d_r_e_s_s___m_a_t_c_h___e_l_e_m_e_n_t

     _a_d_d_r_e_s_s___m_a_t_c_h___e_l_e_m_e_n_t = [ "!" ] ( _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t /
                                       _i_p___a_d_d_r_e_s_s / _i_p___p_r_e_f_i_x /
                                       _a_c_l___n_a_m_e / "key " _k_e_y___i_d ) ";"


   DDeeffiinniittiioonn aanndd UUssaaggee

     Address match lists are primarily used to determine access control for
     various server operations.  They are also used to define priorities for
     querying other nameservers and to set the addresses on which nnaammeedd will
     listen for queries.  The elements which constitute an address match list
     can be any of the following:


     ++oo   an _i_p_-_a_d_d_r_e_s_s (in _d_o_t_t_e_d_-_d_e_c_i_m_a_l notation,

     ++oo   an _i_p_-_p_r_e_f_i_x (in the '/'-notation),

     ++oo   A _k_e_y___i_d, as defined by the kkeeyy statement,

     ++oo   the name of an address match list previously defined with the aaccll
         statement, or

     ++oo   another _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t.


     Elements can be negated with a leading exclamation mark (``!''), and the
     match list names any, none, localhost and localnets are predefined.  More
     information on those names can be found in the description of the aaccll
     statement.


     The addition of the kkeeyy clause made the name of this syntactic element
     something of a misnomer, since security keys can be used to validate ac-
     cess without regard to a host or network address.  Nonetheless, the term
     ``address match list'' is still used throughout the documentation.


     When a given IP address or prefix is compared to an address match list,
     the list is traversed in order until an element matches.  The interpreta-
     tion of a match depends on whether the list is being used for access con-
     trol, defining lliisstteenn--oonn ports, or as a topology, and whether the element
     was negated.


     When used as an access control list, a non-negated match allows access
     and a negated match denies access.  If there is no match at all in the
     list, access is denied.  The clauses aallllooww--qquueerryy, aallllooww--ttrraannssffeerr, aallllooww--
     uuppddaattee, aallllooww--rreeccuurrssiioonn, and bbllaacckkhhoollee all use address match lists like
     this.  Similarly, the lliisstteenn--oonn option will cause the server to not ac-
     cept queries on any of the machine's addresses which do not match the
     list.


     When used with the ttooppoollooggyy option, a non-negated match returns a dis-
     tance based on its position on the list (the closer the match is to the
     start of the list, the shorter the distance is between it and the serv-
     er).  A negated match will be assigned the maximum distance from the
     server.  If there is no match, the address will get a distance which is
     further than any non-negated list element, and closer than any negated
     element.


     Because of the first-match aspect of the algorithm, an element that de-
     fines a subset of another element in the list should come before the
     broader element, regardless of whether either is negated.  For example,
     in
           1.2.3/24; !1.2.3.13
     the 1.2.3.13 element is completely useless, because the algorithm will
     match any lookup for 1.2.3.13 to the 1.2.3/24 element.  Using
           !1.2.3.13; 1.2.3/24
     fixes that problem by having 1.2.3.13 blocked by the negation but all
     other 1.2.3.* hosts fall through.


TTHHEE LLOOGGGGIINNGG SSTTAATTEEMMEENNTT
   SSyynnttaaxx


     logging {
       [ channel _c_h_a_n_n_e_l___n_a_m_e {
         ( file _p_a_t_h___n_a_m_e
            [ versions ( _n_u_m_b_e_r | unlimited ) ]
            [ size _s_i_z_e___s_p_e_c ]
          | syslog ( kern | user | mail | daemon | auth | syslog | lpr |
                     news | uucp | cron | authpriv | ftp |
                     local0 | local1 | local2 | local3 |
                     local4 | local5 | local6 | local7 )
          | null );

         [ severity ( critical | error | warning | notice |
                      info  | debug [ _l_e_v_e_l ] | dynamic ); ]
         [ print-category _y_e_s___o_r___n_o; ]
         [ print-severity _y_e_s___o_r___n_o; ]
         [ print-time _y_e_s___o_r___n_o; ]
       }; ]

       [ category _c_a_t_e_g_o_r_y___n_a_m_e {
         _c_h_a_n_n_e_l___n_a_m_e; [ _c_h_a_n_n_e_l___n_a_m_e; ... ]
       }; ]
       ...
     };


   DDeeffiinniittiioonn aanndd UUssaaggee

     The llooggggiinngg statement configures a wide variety of logging options for
     the nameserver.  Its cchhaannnneell phrase associates output methods, format op-
     tions and severity levels with a name that can then be used with the
     ccaatteeggoorryy phrase to select how various classes of messages are logged.



     Only one llooggggiinngg statement is used to define as many channels and cate-
     gories as are wanted.  If there are multiple logging statements in a con-
     figuration, the first defined determines the logging, and warnings are
     issued for the others.  If there is no logging statement, the logging
     configuration will be:


         logging {
             category default { default_syslog; default_debug; };
             category panic { default_syslog; default_stderr; };
             category packet { default_debug; };
             category eventlib { default_debug; };
         };

     The logging configuration is established as soon as the llooggggiinngg statement
     is parsed.  If you want to redirect messages about processing of the en-
     tire configuration file, the llooggggiinngg statement must appear first.  Even
     if you do not redirect configuration file parsing messages, we recommend
     always putting the llooggggiinngg statement first so that this rule need not be
     consciously recalled if you ever do need want the parser's messages relo-
     cated.


   TThhee cchhaannnneell pphhrraassee

     All log output goes to one or more ``channels''; you can make as many of
     them as you want.


     Every channel definition must include a clause that says whether messages
     selected for the channel go to a file, to a particular syslog facility,
     or are discarded.  It can optionally also limit the message severity lev-
     el that will be accepted by the channel (default is info), and whether to
     include a time stamp generated by nnaammeedd, the category name, or severity
     level.  The default is not to include any of those three.


     The word null as the destination option for the channel will cause all
     messages sent to it to be discarded; other options for the channel are
     meaningless.


     The ffiillee clause can include limitations both on how large the file is al-
     lowed to become, and how many versions of the file will be saved each
     time the file is opened.


     The ssiizzee option for files is simply a hard ceiling on log growth.  If the
     file ever exceeds the size, then nnaammeedd will just not write anything more
     to it until the file is reopened; exceeding the size does not automati-
     cally trigger a reopen.  The default behavior is to not limit the size of
     the file.


     If you use the vveerrssiioonn logfile option, then nnaammeedd will retain that many
     backup versions of the file by renaming them when opening.  For example,
     if you choose to keep 3 old versions of the file lamers.log then just be-
     fore it is opened lamers.log.1 is renamed to lames.log.2, lamers.log.0 is
     renamed to lamers.log.1, and lamers.log is renamed to lamers.log.0.  No
     rolled versions are kept by default; any existing log file is simply ap-
     pended.  The unlimited keyword is synonymous with 99 in current BIND re-
     leases.  Example usage of size and versions options:


         channel an_example_level {
             file "lamers.log" versions 3 size 20m;
             print-time yes;
             print-category yes;
         };


     The argument for the ssyysslloogg clause is a syslog facility as described in
     the syslog(3) manual page.  How ssyyssllooggdd will handle messages sent to this
     facility is described in the syslog.conf(5) manual page.  If you have a
     system which uses a very old version of syslog that only uses two argu-
     ments to the ooppeennlloogg(())() function, then this clause is silently ignored.


     The sseevveerriittyy clause works like syslog's ``priorities'', except that they
     can also be used if you are writing straight to a file rather than using
     syslog.  Messages  which are not at least of the severity level given
     will not be selected for the channel; messages of higher severity levels
     will be accepted.


     If you are using syslog, then the _s_y_s_l_o_g_._c_o_n_f priorities will also deter-
     mine what eventually passes through.  For example, defining a channel fa-
     cility and severity as daemon and debug but only logging daemon.warning
     via _s_y_s_l_o_g_._c_o_n_f will cause messages of severity info and notice to be
     dropped.  If the situation were reversed, with nnaammeedd writing messages of
     only warning or higher, then ssyyssllooggdd would print all messages it received
     from the channel.


     The server can supply extensive debugging information when it is in de-
     bugging mode.  If the server's global debug level is greater than zero,
     then debugging mode will be active.  The global debug level is set either
     by starting the nnaammeedd server with the --dd flag followed by a positive in-
     teger, or by sending the running server the SIGUSR1 signal (for example,
     by using nnddcc ttrraaccee). The global debug level can be set to zero, and de-
     bugging mode turned off, by sending the server the SIGUSR2 signal (as
     with nnddcc nnoottrraaccee). All debugging messages in the server have a debug lev-
     el, and higher debug levels give more more detailed output.  Channels
     that specify a specific debug severity, e.g.


         channel specific_debug_level {
             file "foo";
             severity debug 3;
         };

     will get debugging output of level 3 or less any time the server is in
     debugging mode, regardless of the global debugging level.  Channels with
     dynamic severity use the server's global level to determine what messages
     to print.


     If pprriinntt--ttiimmee has been turned on, then the date and time will be logged.
     pprriinntt--ttiimmee may be specified for a syslog channel, but is usually point-
     less since syslog also prints the date and time.  If pprriinntt--ccaatteeggoorryy is
     requested, then the category of the message will be logged as well.  Fi-
     nally, if pprriinntt--sseevveerriittyy is on, then the severity level of the message
     will be logged.  The pprriinntt-- options may be used in any combination, and
     will always be printed in the following order: time, category, severity.
     Here is an example where all three pprriinntt-- options are on:


         28-Apr-1997 15:05:32.863 default: notice: Ready to answer queries.


     There are four predefined channels that are used for nnaammeedd ''ss default
     logging as follows.  How they are used used is described in the next sec-
     tion, _T_h_e _c_a_t_e_g_o_r_y _p_h_r_a_s_e_.


         channel default_syslog {
             syslog daemon;       # send to syslog's daemon facility
             severity info;       # only send priority info and higher
         };

         channel default_debug {
             file "named.run";    # write to named.run in the working directory
                                  # Note: stderr is used instead of "named.run"
                                  # if the server is started with the -f option.
             severity dynamic;    # log at the server's current debug level
         };

         channel default_stderr { # writes to stderr
             file "<stderr>";     # this is illustrative only; there's currently
                                  # no way of specifying an internal file
                                  # descriptor in the configuration language.
             severity info;       # only send priority info and higher
         };

         channel null {
             null;                # toss anything sent to this channel
         };

     Once a channel is defined, it cannot be redefined.  Thus you cannot alter
     the built-in channels directly, but you can modify the default logging by
     pointing categories at channels you have defined.


   TThhee ccaatteeggoorryy pphhrraassee

     There are many categories, so you can send the logs you want to see wher-
     ever you want, without seeing logs you don't want.  If you don't specify
     a list of channels for a category, then log messages in that category
     will be sent to the default category instead.  If you don't specify a de-
     fault category, the following ``default default'' is used:


         category default { default_syslog; default_debug; };

     As an example, let's say you want to log security events to a file, but
     you also want keep the default logging behavior.  You'd specify the fol-
     lowing:


         channel my_security_channel {
             file "my_security_file";
             severity info;
         };
         category security { my_security_channel;
                             default_syslog; default_debug; };

     To discard all messages in a category, specify the null channel:


         category lame-servers { null; };
         category cname { null; };

     The following categories are available:


     ddeeffaauulltt
       The catch-all.  Many things still aren't classified into categories,
       and they all end up here.  Also, if you don't specify any channels for
       a category, the default category is used instead.  If you do not define
       the default category, the following definition is used:
             category default { default_syslog; default_debug; };


     ccoonnffiigg
       High-level configuration file processing.


     ppaarrsseerr
       Low-level configuration file processing.


     qquueerriieess
       A short log message is generated for every query the server receives.


     llaammee--sseerrvveerrss
       Messages like ``Lame server on ...''


     ssttaattiissttiiccss
       Statistics.


     ppaanniicc
       If the server has to shut itself down due to an internal problem, it
       will log the problem in this category as well as in the problem's na-
       tive category.  If you do not define the panic category, the following
       definition is used:
             category panic { default_syslog; default_stderr; };


     uuppddaattee
       Dynamic updates.


     nnccaacchhee
       Negative caching.


     xxffeerr--iinn
       Zone transfers the server is receiving.


     xxffeerr--oouutt
       Zone transfers the server is sending.


     ddbb
       All database operations.


     eevveennttlliibb
       Debugging info from the event system.  Only one channel may be speci-
       fied for this category, and it must be a file channel.  If you do not
       define the eventlib category, the following definition is used:
             category eventlib { default_debug; };


     ppaacckkeett
       Dumps of packets received and sent.  Only one channel may be specified
       for this category, and it must be a file channel.  If you do not define
       the packet category, the following definition is used:
             category packet { default_debug; };



     nnoottiiffyy
       The NOTIFY protocol.


     ccnnaammee
       Messages like ``... points to a CNAME''.


     sseeccuurriittyy
       Approved/unapproved requests.


     ooss
       Operating system problems.


     iinnssiisstt
       Internal consistency check failures.


     mmaaiinntteennaannccee
       Periodic maintenance events.


     llooaadd
       Zone loading messages.


     rreessppoonnssee--cchheecckkss
       Messages arising from response checking, such as ``Malformed response
       ...'', ``wrong ans. name ...'', ``unrelated additional info ...'',
       ``invalid RR type ...'', and ``bad referral ...''.



TTHHEE OOPPTTIIOONNSS SSTTAATTEEMMEENNTT
   SSyynnttaaxx


     options {
       [ version _v_e_r_s_i_o_n___s_t_r_i_n_g; ]
       [ directory _p_a_t_h___n_a_m_e; ]
       [ named-xfer _p_a_t_h___n_a_m_e; ]
       [ dump-file _p_a_t_h___n_a_m_e; ]
       [ memstatistics-file _p_a_t_h___n_a_m_e; ]
       [ pid-file _p_a_t_h___n_a_m_e; ]
       [ statistics-file _p_a_t_h___n_a_m_e; ]
       [ auth-nxdomain _y_e_s___o_r___n_o; ]
       [ deallocate-on-exit _y_e_s___o_r___n_o; ]
       [ dialup _y_e_s___o_r___n_o; ]
       [ fake-iquery _y_e_s___o_r___n_o; ]
       [ fetch-glue _y_e_s___o_r___n_o; ]
       [ has-old-clients _y_e_s___o_r___n_o; ]
       [ host-statistics _y_e_s___o_r___n_o; ]
       [ host-statistics-max _n_u_m_b_e_r; ]
       [ multiple-cnames _y_e_s___o_r___n_o; ]
       [ notify _y_e_s___o_r___n_o; ]
       [ recursion _y_e_s___o_r___n_o; ]
       [ rfc2308-type1 _y_e_s___o_r___n_o; ]
       [ use-id-pool _y_e_s___o_r___n_o; ]
       [ treat-cr-as-space _y_e_s___o_r___n_o; ]
       [ also-notify _y_e_s___o_r___n_o; ]
       [ forward ( only | first ); ]
       [ forwarders { [ _i_n___a_d_d_r ; [ _i_n___a_d_d_r ; ... ] ] }; ]
       [ check-names ( master | slave | response ) ( warn | fail | ignore); ]
       [ allow-query { _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t }; ]
       [ allow-recursion { _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t }; ]
       [ allow-transfer { _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t }; ]
       [ blackhole { _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t }; ]
       [ listen-on [ port _i_p___p_o_r_t ] { _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t }; ]
       [ query-source [ address ( _i_p___a_d_d_r | * ) ]
                      [ port ( _i_p___p_o_r_t | * ) ] ; ]
       [ lame-ttl _n_u_m_b_e_r; ]
       [ max-transfer-time-in _n_u_m_b_e_r; ]
       [ max-ncache-ttl _n_u_m_b_e_r; ]
       [ min-roots _n_u_m_b_e_r; ]
       [ serial-queries _n_u_m_b_e_r; ]
       [ transfer-format ( one-answer | many-answers ); ]
       [ transfers-in  _n_u_m_b_e_r; ]
       [ transfers-out _n_u_m_b_e_r; ]
       [ transfers-per-ns _n_u_m_b_e_r; ]
       [ transfer-source _i_p___a_d_d_r; ]
       [ maintain-ixfr-base _y_e_s___o_r___n_o; ]
       [ max-ixfr-log-size _n_u_m_b_e_r; ]
       [ coresize _s_i_z_e___s_p_e_c ; ]
       [ datasize _s_i_z_e___s_p_e_c ; ]
       [ files _s_i_z_e___s_p_e_c ; ]
       [ stacksize _s_i_z_e___s_p_e_c ; ]
       [ cleaning-interval _n_u_m_b_e_r; ]
       [ heartbeat-interval _n_u_m_b_e_r; ]
       [ interface-interval _n_u_m_b_e_r; ]
       [ statistics-interval _n_u_m_b_e_r; ]
       [ topology { _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t }; ]
       [ sortlist { _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t_|_f_R _}_; _]
       _[ _r_r_s_e_t_-_o_r_d_e_r _{ _o_r_d_e_r___s_p_e_c ; [ _o_r_d_e_r___s_p_e_c ; ... [ [ };
     };


   DDeeffiinniittiioonn aanndd UUssaaggee

     The options statement sets up global options to be used by BIND. This
     statement may appear at only once in a configuration file; if more than
     one occurrence is found, the first occurrence determines the actual op-
     tions used, and a warning will be generated.  If there is no options
     statement, an options block with each option set to its default will be
     used.


   PPaatthhnnaammeess



     vveerrssiioonn
       The version the server should report via the ndc command or via a query
       of name _v_e_r_s_i_o_n_._b_i_n_d in class chaos. The default is the real version
       number of ths server, but some server operators prefer the string (
       ssuurreellyy yyoouu mmuusstt bbee jjookkiinngg ).


     ddiirreeccttoorryy
       The working directory of the server.  Any non-absolute pathnames in the
       configuration file will be taken as relative to this directory.  The
       default location for most server output files (e.g.  _n_a_m_e_d_._r_u_n) is this
       directory.  If a directory is not specified, the working directory de-
       faults to ., the directory from which the server was started.  The di-
       rectory specified should be an absolute path.


     nnaammeedd--xxffeerr
       The pathname to the named-xfer program that the server uses for inbound
       zone transfers.  If not specified, the default is system dependent
       (e.g.  _/_u_s_r_/_s_b_i_n_/_n_a_m_e_d_-_x_f_e_r ).


     dduummpp--ffiillee
       The pathname of the file the server dumps the database to when it re-
       ceives SIGINT signal (as sent by nnddcc dduummppddbb ). If not specified, the
       default is _n_a_m_e_d___d_u_m_p_._d_b.


     mmeemmssttaattiissttiiccss--ffiillee
       The pathname of the file the server writes memory usage statistics to
       on exit, if ddeeaallllooccaattee--oonn--eexxiitt is yes. If not specified, the default is
       _n_a_m_e_d_._m_e_m_s_t_a_t_s.


     ppiidd--ffiillee
       The pathname of the file the server writes its process ID in.  If not
       specified, the default is operating system dependent, but is usually
       _/_v_a_r_/_r_u_n_/_n_a_m_e_d_._p_i_d or _/_e_t_c_/_n_a_m_e_d_._p_i_d. The pid-file is used by programs
       like nnddcc that want to send signals to the running nameserver.


     ssttaattiissttiiccss--ffiillee
       The pathname of the file the server appends statistics to when it re-
       ceives SIGILL signal (from nnddcc ssttaattss). If not specified, the default is
       _n_a_m_e_d_._s_t_a_t_s.


   BBoooolleeaann OOppttiioonnss


     aauutthh--nnxxddoommaaiinn
       If yes, then the AA bit is always set on NXDOMAIN responses, even if
       the server is not actually authoritative.  The default is yes. Do not
       turn off aauutthh--nnxxddoommaaiinn unless you are sure you know what you are doing,
       as some older software won't like it.


     ddeeaallllooccaattee--oonn--eexxiitt
       If yes, then when the server exits it will painstakingly deallocate ev-
       ery object it allocated, and then write a memory usage report to the
       mmeemmssttaattiissttiiccss--ffiillee. The default is no, because it is faster to let the
       operating system clean up.  ddeeaallllooccaattee--oonn--eexxiitt is handy for detecting
       memory leaks.


     ddiiaalluupp
       If yes, then the server treats all zones as if they are doing zone
       transfers across a dial on demand dialup link, which can be brought up
       by traffic originating from this server.  This has different effects
       according to zone type and concentrates the zone maintenance so that it
       all happens in a short interval, once every hheeaarrttbbeeaatt--iinntteerrvvaall and
       hopefully during the one call.  It also suppresses some of the normal
       zone maintenance traffic.  The default is no. The ddiiaalluupp option may al-
       so be specified in the zzoonnee statement, in which case it overrides the
       ooppttiioonnss ddiiaalluupp statement.


       If the zone is a mmaasstteerr then the server will send out NOTIFY request to
       all the slaves.  This will trigger the zone up to date checking in the
       slave (providing it supports NOTIFY) allowing  the slave to verify the
       zone while the call us up.



       If the zone is a ssllaavvee or ssttuubb then the server will suppress the zone
       regular zone up to date queries and only perform the when the
       hheeaarrttbbeeaatt--iinntteerrvvaall expires.


     ffaakkee--iiqquueerryy
       If yes, the server will simulate the obsolete DNS query type IQUERY.
       The default is no.


     ffeettcchh--gglluuee
       If yes (the default), the server will fetch ``glue'' resource records
       it doesn't have when constructing the additional data section of a re-
       sponse.  ffeettcchh--gglluuee nnoo can be used in conjunction with rreeccuurrssiioonn nnoo to
       prevent the server's cache from growing or becoming corrupted (at the
       cost of requiring more work from the client).


     hhaass--oolldd--cclliieennttss
       Setting the option to yes, is equivalent to setting the following three
       options: aauutthh--nnxxddoommaaiinn yyeess ;;,, mmaaiinnttaaiinn--iixxffrr--bbaassee yyeess ;;,, and
       rrffcc22330088--ttyyppee11 nnoo; hhaass--oolldd--cclliieennttss with aauutthh--nnxxddoommaaiinn, mmaaiinnttaaiinn--iixxffrr--
       bbaassee, and rrffcc22330088--ttyyppee11 is order dependant.


     hhoosstt--ssttaattiissttiiccss
       If yes, then statistics are kept for every host that the the nameserver
       interacts with.  The default is no. _N_o_t_e_: turning on hhoosstt--ssttaattiissttiiccss
       can consume huge amounts of memory.


     IC host-statistics-max
       The maximum number of host records that will be kept.  When this limit
       is reached no new hosts will be added to the host statistics.  If the
       set to zero then there is no limit set.  The default value is zero.


     mmaaiinnttaaiinn--iixxffrr--bbaassee
       If yes, a IXFR database file is kept for all dynamicaly updated zones.
       This enables the server to answer IXFR queries which can speed up zone
       transfers enormously.  The default is no.


     mmuullttiippllee--ccnnaammeess
       If yes, then multiple CNAME resource records will be allowed for a do-
       main name.  The default is no. Allowing multiple CNAME records is
       against standards and is not recommended.  Multiple CNAME support is
       available because previous versions of BIND allowed multiple CNAME
       records, and these records have been used for load balancing by a num-
       ber of sites.


     nnoottiiffyy
       If yes (the default), DNS NOTIFY messages are sent when a zone the
       server is authoritative for changes.  The use of NOTIFY speeds conver-
       gence between the master and its slaves.  Slave servers that receive a
       NOTIFY message and understand it will contact the master server for the
       zone and see if they need to do a zone transfer, and if they do, they
       will initiate it immediately.  The nnoottiiffyy option may also be specified
       in the zzoonnee statement, in which case it overrides the ooppttiioonnss nnoottiiffyy
       statement.


     rreeccuurrssiioonn
       If yes, and a DNS query requests recursion, then the server will at-
       tempt to do all the work required to answer the query.  If recursion is
       not on, the server will return a referral to the client if it doesn't
       know the answer.  The default is yes. See also ffeettcchh--gglluuee above.


     rrffcc22330088--ttyyppee11
       If yes, the server will send NS records along with the SOA record for
       negative answers.  You need to set this to no if you have an old BIND
       server using you as a forwarder that does not understand negative an-
       swers which contain both SOA and NS records or you have an old version
       of sendmail.  The correct fix is to upgrade the broken server or send-
       mail.  The default is no.


     uussee--iidd--ppooooll
       If yes, the server will keep track of its own outstanding query ID's to
       avoid duplication and increase randomness.  This will result in 128KB
       more memory being consumed by the server.  The default is no.


     ttrreeaatt--ccrr--aass--ssppaaccee
       If yes, the server will treat CR characters the same way it treats a
       space or tab.  This may be necessary when loading zone files on a UNIX
       system that were generated on an NT or DOS machine.  The default is no.




   AAllssoo--NNoottiiffyy

     aallssoo--nnoottiiffyy

     Defines a global list of IP addresses that also get sent NOTIFY messages
     whenever a fresh copy of the zone is loaded. This helps to ensure that
     copies of the zones will quickly converge on ``stealth'' servers.  If an
     aallssoo--nnoottiiffyy list is given in a zzoonnee statement, it will override the
     ooppttiioonnss aallssoo--nnoottiiffyy statement. When a zzoonnee nnoottiiffyy statement is set to nnoo,
     the IP addresses in the global aallssoo--nnoottiiffyy list will not get sent NOTIFY
     messages for that zone.  The default is the empty list (no global notifi-
     cation list).


   FFoorrwwaarrddiinngg


     The forwarding facility can be used to create a large site-wide cache on
     a few servers, reducing traffic over links to external nameservers.  It
     can also be used to allow queries by servers that do not have direct ac-
     cess to the Internet, but wish to look up exterior names anyway.  For-
     warding occurs only on those queries for which the server is not authori-
     tative and does not have the answer in its cache.


     ffoorrwwaarrdd
       This option is only meaningful if the ffoorrwwaarrddeerrss list is not empty.  A
       value of first, the default, causes the server to query the forwarders
       first, and if that doesn't answer the question the server will then
       look for the answer itself.  If only is specified, the server will only
       query the forwarders.


     ffoorrwwaarrddeerrss
       Specifies the IP addresses to be used for forwarding.  The default is
       the empty list (no forwarding).



     Forwarding can also be configured on a per-zone basis, allowing for the
     global forwarding options to be overridden in a variety of ways.  You can
     set particular zones to use different forwarders, or have different
     ffoorrwwaarrdd oonnllyy//ffiirrsstt behavior, or to not forward at all.  See _T_H_E _Z_O_N_E
     _S_T_A_T_E_M_E_N_T section for more information.


     Future versions of BIND 8 will provide a more powerful forwarding system.
     The syntax described above will continue to be supported.


   NNaammee CChheecckkiinngg

     The server can check domain names based upon their expected client con-
     texts.  For example, a domain name used as a hostname can be checked for
     compliance with the RFCs defining valid hostnames.


     Three checking methods are available:


     iiggnnoorree
       No checking is done.


     wwaarrnn
       Names are checked against their expected client contexts.  Invalid
       names are logged, but processing continues normally.


     ffaaiill
       Names are checked against their expected client contexts.  Invalid
       names are logged, and the offending data is rejected.


     The server can check names three areas: master zone files, slave zone
     files, and in responses to queries the server has initiated.  If cchheecckk--
     nnaammeess rreessppoonnssee ffaaiill has been specified, and answering the client's ques-
     tion would require sending an invalid name to the client, the server will
     send a REFUSED response code to the client.


     The defaults are:


         check-names master fail;
         check-names slave warn;
         check-names response ignore;


     cchheecckk--nnaammeess may also be specified in the zzoonnee statement, in which case it
     overrides the ooppttiioonnss cchheecckk--nnaammeess statement.  When used in a zzoonnee state-
     ment, the area is not specified (because it can be deduced from the zone
     type).


   AAcccceessss CCoonnttrrooll


     Access to the server can be restricted based on the IP address of the re-
     questing system or via shared secret keys.  See _A_D_D_R_E_S_S _M_A_T_C_H _L_I_S_T_S for
     details on how to specify access criteria.


     aallllooww--qquueerryy
       Specifies which hosts are allowed to ask ordinary questions.  aallllooww--
       qquueerryy may also be specified in the zzoonnee statement, in which case it
       overrides the ooppttiioonnss aallllooww--qquueerryy statement.  If not specified, the de-
       fault is to allow queries from all hosts.


       aallllooww--rreeccuurrssiioonn
         Specifies which hosts are allowed to ask recursive questions.  If not
         specified, the default is to allow recursive queries from all hosts.


       aallllooww--ttrraannssffeerr
         Specifies which hosts are allowed to receive zone transfers from the
         server.  aallllooww--ttrraannssffeerr may also be specified in the zzoonnee statement,
         in which case it overrides the ooppttiioonnss aallllooww--ttrraannssffeerr statement.  If
         not specified, the default is to allow transfers from all hosts.


       bbllaacckkhhoollee
         Specifies a list of addresses that the server will not accept queries
         from or use to resolve a query.  Queries from these addresses will
         not be responded to.


   IInntteerrffaacceess


     The interfaces and ports that the server will answer queries from may be
     specified using the lliisstteenn--oonn option.  lliisstteenn--oonn takes an optional port,
     and an address match list.  The server will listen on all interfaces al-
     lowed by the address match list.  If a port is not specified, port 53
     will be used.


     Multiple lliisstteenn--oonn statements are allowed.  For example,


         listen-on { 5.6.7.8; };
         listen-on port 1234 { !1.2.3.4; 1.2/16; };

     will enable the nameserver on port 53 for the IP address 5.6.7.8, and on
     port 1234 of an address on the machine in net 1.2 that is not 1.2.3.4.


     If no lliisstteenn--oonn is specified, the server will listen on port 53 on all
     interfaces.


   QQuueerryy AAddddrreessss


     If the server doesn't know the answer to a question, it will query other
     nameservers.  qquueerryy--ssoouurrccee specifies the address and port used for such
     queries.  If aaddddrreessss is * or is omitted, a wildcard IP address (
     INADDR_ANY) will be used.  If _p_o_r_t is * or is omitted, a random unprivi-
     leged port will be used.  The default is
           query-source address * port *;


     Note: qquueerryy--ssoouurrccee currently applies only to UDP queries; TCP queries al-
     ways use a wildcard IP address and a random unprivileged port.


   ZZoonnee TTrraannssffeerrss




     mmaaxx--ttrraannssffeerr--ttiimmee--iinn
       Inbound zone transfers ( nnaammeedd--xxffeerr processes) running longer than this
       many minutes will be terminated.  The default is 120 minutes (2 hours).


     ttrraannssffeerr--ffoorrmmaatt
       The server supports two zone transfer methods.  one-answer uses one DNS
       message per resource record transferred.  many-answers packs as many
       resource records as possible into a message.  many-answers is more ef-
       ficient, but is only known to be understood by BIND 8.1 and patched
       versions of BIND 4.9.5.  The default is one-answer. ttrraannssffeerr--ffoorrmmaatt may
       be overridden on a per-server basis by using the sseerrvveerr statement.


     ttrraannssffeerrss--iinn
       The maximum number of inbound zone transfers that can be running con-
       currently.  The default value is 10.  Increasing ttrraannssffeerrss--iinn may speed
       up the convergence of slave zones, but it also may increase the load on
       the local system.


     ttrraannssffeerrss--oouutt
       This option will be used in the future to limit the number of concur-
       rent outbound zone transfers.  It is checked for syntax, but is other-
       wise ignored.


     ttrraannssffeerrss--ppeerr--nnss
       The maximum number of inbound zone transfers ( nnaammeedd--xxffeerr processes)
       that can be concurrently transferring from a given remote nameserver.
       The default value is 2.  Increasing ttrraannssffeerrss--ppeerr--nnss may speed up the
       convergence of slave zones, but it also may increase the load on the
       remote nameserver.  ttrraannssffeerrss--ppeerr--nnss may be overridden on a per-server
       basis by using the ttrraannssffeerrss phrase of the sseerrvveerr statement.


     ttrraannssffeerr--ssoouurrccee
       ttrraannssffeerr--ssoouurrccee determines which local address will be bound to the TCP
       connection used to fetch all zones transferred inbound by the server.
       If not set, it defaults to a system controlled value which will usually
       be the address of the interface ``closest to`` the remote end.  This
       address must appear in the remote end's aallllooww--ttrraannssffeerr option for the
       zones being transferred, if one is specified.  This statement sets the
       ttrraannssffeerr--ssoouurrccee for all zones, but can be overriden on a per-zone basis
       by includinga ttrraannssffeerr--ssoouurrccee statement within the zone block in the
       configuration file.


   RReessoouurrccee LLiimmiittss


     The server's usage of many system resources can be limited.  Some operat-
     ing systems don't support some of the limits.  On such systems, a warning
     will be issued if the unsupported limit is used.  Some operating systems
     don't support limiting resources, and on these systems a
           set resource limits on this system
     message will be logged.


     Scaled values are allowed when specifying resource limits.  For example,
     1G can be used instead of 1073741824 to specify a limit of one gigabyte.
     unlimited requests unlimited use, or the maximum available amount.
     default uses the limit that was in force when the server was started.
     See the definition of _s_i_z_e___s_p_e_c in the _D_O_C_U_M_E_N_T_A_T_I_O_N _D_E_F_I_N_I_T_I_O_N_S section
     for more details.


     ccoorreessiizzee
       The maximum size of a core dump.  The default value is default.


     ddaattaassiizzee
       The maximum amount of data memory the server may use.  The default val-
       ue is default.


     ffiilleess
       The maximum number of files the server may have open concurrently.  The
       default value is unlimited. Note that on some operating systems the
       server cannot set an unlimited value and cannot determine the maximum
       number of open files the kernel can support.  On such systems, choosing
       unlimited will cause the server to use the larger of the _r_l_i_m___m_a_x from
       ggeettrrlliimmiitt(_R_L_I_M_I_T___N_O_F_I_L_E) and the value returned by
       ssyyssccoonnff(___S_C___O_P_E_N___M_A_X).  If the actual kernel limit is larger than this
       value, use lliimmiitt ffiilleess to specify the limit explicitly.


     mmaaxx--iixxffrr--lloogg--ssiizzee
       The max-ixfr-log-size will be used in a future release of the server to
       limit the size of the transaction log kept for Incremental Zone Trans-
       fer.


     ssttaacckkssiizzee
       The maximum amount of stack memory the server may use.  The default
       value is default.


   PPeerriiooddiicc TTaasskk IInntteerrvvaallss


     cclleeaanniinngg--iinntteerrvvaall
       The server will remove expired resource records from the cache every

       cclleeaanniinngg--iinntteerrvvaall minutes.  The default is 60 minutes.  If set to 0, no
       periodic cleaning will occur.


     hheeaarrttbbeeaatt--iinntteerrvvaall
       The server will perform zone maintenance tasks for all zones marked
       ddiiaalluupp yyeess whenever this interval expires.  The default is 60 minutes.
       Reasonable values are up to 1 day (1440 minutes).  If set to 0, no zone
       maintenance for these zones will occur.


     iinntteerrffaaccee--iinntteerrvvaall
       The server will scan the network interface list every iinntteerrffaaccee--
       iinntteerrvvaall minutes.  The default is 60 minutes.  If set to 0, interface
       scanning will only occur when the configuration file is loaded.  After
       the scan, listeners will be started on any new interfaces (provided
       they are allowed by the lliisstteenn--oonn configuration).  Listeners on inter-
       faces that have gone away will be cleaned up.


     ssttaattiissttiiccss--iinntteerrvvaall
       Nameserver statistics will be logged every ssttaattiissttiiccss--iinntteerrvvaall minutes.
       The default is 60.  If set to 0, no statistics will be logged.


   TTooppoollooggyy


     All other things being equal, when the server chooses a nameserver to
     query from a list of nameservers, it prefers the one that is topological-
     ly closest to itself.  The ttooppoollooggyy statement takes an address match list
     and interprets it in a special way.  Each top-level list element is as-
     signed a distance.  Non-negated elements get a distance based on their
     position in the list, where the closer the match is to the start of the
     list, the shorter the distance is between it and the server.  A negated
     match will be assigned the maximum distance from the server.  If there is
     no match, the address will get a distance which is further than any non-
     negated list element, and closer than any negated element.  For example,


         topology {
             10/8;
             !1.2.3/24;
             { 1.2/16; 3/8; };
         };

     will prefer servers on network 10 the most, followed by hosts on network
     1.2.0.0 (netmask 255.255.0.0) and network 3, with the exception of hosts
     on network 1.2.3 (netmask 255.255.255.0), which is preferred least of
     all.


     The default topology is
           topology { localhost; localnets; };


   RReessoouurrccee RReeccoorrdd ssoorrttiinngg


     When returning multiple RRs, the nameserver will normally return them in
     RRoouunndd RRoobbiinn, i.e. after each request, the first RR is put to the end of
     the list.  As the order of RRs is not defined, this should not cause any
     problems.

     The client resolver code should re-arrange the RRs as appropriate, i.e.
     using any addresses on the local net in preference to other addresses.
     However, not all resolvers can do this, or are not correctly configured.

     When a client is using a local server, the sorting can be performed in
     the server, based on the client's address. This only requires configuring
     the nameservers, not all the clients.

     The ssoorrttlliisstt statement takes an address match list and interprets it even
     more specially than the statement does.

     Each top level statement in the sortlist must itself be an explicit ad-
     dress match list with one or two elements. The first element (which may
     be an IP address, an IP prefix, an ACL name or nested address match list)
     of each top level list is checked against the source address of the query
     until a match is found.

     Once the source address of the query has been matched, if the top level
     statement contains only one element, the actual primitive element that
     matched the source address is used to select the address in the response
     to move to the beginning of the response. If the statement is a list of
     two elements, the second element is treated like the address match list
     in a topology statement. Each top level element is assigned a distance
     and the address in the response with the minimum distance is moved to the
     beginning of the response.

     In the following example, any queries received from any of the addresses
     of the host itself will get responses preferring addresses on any of the
     locally connected networks. Next most preferred are addresses on the
     192.168.1/24 network, and after that either the 192.168.2/24 or
     192.168.3/24 network with no preference shown between these two networks.
     Queries received from a host on the 192.168.1/24 network will prefer oth-
     er addresses on that network to the 192.168.2/24 and 192.168.3/24 net-
     works. Queries received from a host on the 192.168.4/24 or the
     192.168.5/24 network will only prefer other addresses on their directly
     connected networks.


     sortlist {
                { localhost;         // IF   the local host
                  { localnets;       // THEN first fit on the
                    192.168.1/24;    //      following nets
                    { 192,168.2/24; 192.168.3/24; }; }; };
                { 192.168.1/24;      // IF   on class C 192.168.1
                  { 192.168.1/24;    // THEN use .1, or .2 or .3
                    { 192.168.2/24; 192.168.3/24; }; }; };
                { 192.168.2/24;      // IF   on class C 192.168.2
                  { 192.168.2/24;    // THEN use .2, or .1 or .3
                    { 192.168.1/24; 192.168.3/24; }; }; };
                { 192.168.3/24;      // IF   on class C 192.168.3
                  { 192.168.3/24;    // THEN use .3, or .1 or .2
                    { 192.168.1/24; 192.168.2/24; }; }; };
                { { 192.168.4/24; 192.168.5/24; }; // if .4 or .5, prefer that net
                };
     };

     The following example will give reasonable behaviour for the local host
     and hosts on directly connected networks. It is similar to the behavior
     of the address sort in BIND 4.9.x. Responses sent to queries from the lo-
     cal host will favor any of the directly connected networks. Responses
     sent to queries from any other hosts on a directly connected network will
     prefer addresses on that same network. Responses to other queries will
     not be sorted.


     sortlist {
                 { localhost; localnets; };
                 { localnets; };
     };


   RRRRsseett OOrrddeerriinngg


     When multiple records are returned in an answer it may be useful to con-
     figure the order the records are placed into the response. For example
     the records for a zone might be configured to always be returned in the
     order they are defined in the zone file. Or perhaps a random shuffle of
     the records as they are returned is wanted. The rrset-order statement
     permits configuration of the ordering made of the records in a multiple
     record response. The default, if no ordering is defined, is a cyclic or-
     dering (round robin).

     An oorrddeerr__ssppeecc is defined as follows:


       [ _c_l_a_s_s _c_l_a_s_s___n_a_m_e ][ _t_y_p_e _t_y_p_e___n_a_m_e ][ _n_a_m_e "FQDN" ] _o_r_d_e_r ordering

     If no class is specified, the default is AANNYY. If no Ictype is specified,
     the default is AANNYY. If no name is specified, the default is "*".

     The legal values for oorrddeerriinngg are:


     ffiixxeedd
          Records are returned in the order they are defined in the zone file.
     rraannddoomm
          Records are returned in some random order.
     ccyycclliicc
          Records are returned in a round-robin order.

     For example:

         rrset-order {
             class IN type A name "rc.vix.com" order random;
             order cyclic;
         };

     will cause any responses for type A records in class IN that have
     "rc.vix.com" as a suffix, to always be returned in random order. All oth-
     er records are returned in cyclic order.

     If multiple rrrrsseett--oorrddeerr statements appear, they are not combined--the
     last one applies.

     If no rrrrsseett--oorrddeerr statement is specified, a default one of:


         rrset-order { class ANY type ANY name "*" order cyclic ; };

     is used.


   TTuunniinngg


     llaammee--ttttll
       Sets the number of seconds to cache a lame server indication.  0 dis-
       ables caching.  Default is 600 (10 minutes).  Maximum value is 1800 (30
       minutes)

     mmaaxx--nnccaacchhee--ttttll
       To reduce network traffic and increase performance the server store
       negative answers.  mmaaxx--nnccaacchhee--ttttll is used to set a maximum retention
       time for these answers in the server is seconds.  The default mmaaxx--
       nnccaacchhee--ttttll is 10800 seconds (3 hours).  mmaaxx--nnccaacchhee--ttttll cannot exceed
       the maximum retention time for ordinary (positive) answers (7 days) and
       will be silently truncated to 7 days if set to a value which is greater
       that 7 days.

     mmiinn--rroooottss
       The minimum number of root servers that is required for a request for
       the root servers to be accepted.  Default is 2.


TTHHEE ZZOONNEE SSTTAATTEEMMEENNTT
   SSyynnttaaxx


     zone _d_o_m_a_i_n___n_a_m_e [ ( in | hs | hesiod | chaos ) ] {
       type master;
       file _p_a_t_h___n_a_m_e;
       [ check-names ( warn | fail | ignore ); ]
       [ allow-update { _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t }; ]
       [ allow-query { _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t }; ]
       [ allow-transfer { _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t }; ]
       [ forward ( only | first ); ]
       [ forwarders { [ _i_p___a_d_d_r ; [ _i_p___a_d_d_r ; ... ] ] }; ]
       [ dialup _y_e_s___o_r___n_o; ]
       [ notify _y_e_s___o_r___n_o; ]
       [ also-notify { _i_p___a_d_d_r; [ _i_p___a_d_d_r; ... ] };
       [ pubkey _n_u_m_b_e_r _n_u_m_b_e_r _n_u_m_b_e_r _s_t_r_i_n_g; ]
     };

     zone _d_o_m_a_i_n___n_a_m_e [ ( in | hs | hesiod | chaos ) ] {
       type ( slave | stub );
       [ file _p_a_t_h___n_a_m_e; ]
       masters [ port _i_p___p_o_r_t ] { _i_p___a_d_d_r; [ _i_p___a_d_d_r; ... ] };
       [ check-names ( warn | fail | ignore ); ]
       [ allow-update { _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t }; ]
       [ allow-query { _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t }; ]
       [ allow-transfer { _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t }; ]
       [ forward ( only | first ); ]
       [ forwarders { [ _i_p___a_d_d_r ; [ _i_p___a_d_d_r ; ... ] ] }; ]
       [ transfer-source _i_p___a_d_d_r; ]
       [ max-transfer-time-in _n_u_m_b_e_r; ]
       [ notify _y_e_s___o_r___n_o; ]
       [ also-notify { _i_p___a_d_d_r; [ _i_p___a_d_d_r; ... ] };
       [ pubkey _n_u_m_b_e_r _n_u_m_b_e_r _n_u_m_b_e_r _s_t_r_i_n_g; ]
     };

     zone _d_o_m_a_i_n___n_a_m_e [ ( in | hs | hesiod | chaos ) ] {
       type forward;
       [ forward ( only | first ); ]
       [ forwarders { [ _i_p___a_d_d_r ; [ _i_p___a_d_d_r ; ... ] ] }; ]
       [ check-names ( warn | fail | ignore ); ]
     };

     zone "." [ ( in | hs | hesiod | chaos ) ] {
       type hint;
       file _p_a_t_h___n_a_m_e;
       [ check-names ( warn | fail | ignore ); ]
     };


   DDeeffiinniittiioonn aanndd UUssaaggee

     The zzoonnee statement is used to define how information about particular DNS
     zones is managed by the server.  There are five different zone types.


     mmaasstteerr
       The server has a master copy of the data for the zone and will be able
       to provide authoritative answers for it.


     ssllaavvee
       A ssllaavvee zone is a replica of a master zone.  The mmaasstteerrss list specifies
       one or more IP addresses that the slave contacts to update its copy of
       the zone.  If a ppoorrtt is specified then checks to see if the zone is
       current and zone transfers will be done to the port given. If ffiillee is
       specified, then the replica will be written to the named file.  Use of
       the ffiillee clause is highly recommended, since it often speeds server
       startup and eliminates a needless waste of bandwidth.


     ssttuubb
       A ssttuubb zone is like a slave zone, except that it replicates only the NS
       records of a master zone instead of the entire zone.


     ffoorrwwaarrdd
       A ffoorrwwaarrdd zone is used to direct all queries in it to other servers, as
       described in _T_H_E _O_P_T_I_O_N_S _S_T_A_T_E_M_E_N_T section.  The specification of op-
       tions in such a zone will override any global options declared in the
       ooppttiioonnss statement.


       If either no ffoorrwwaarrddeerrss clause is present in the zone or an empty list
       for ffoorrwwaarrddeerrss is given, then no forwarding will be done for the zone,
       cancelling the effects of any ffoorrwwaarrddeerrss in the ooppttiioonnss statement.
       Thus if you want to use this type of zone to change only the behavior
       of the global ffoorrwwaarrdd option, and not the servers used, then you also
       need to respecify the global forwarders.


     hhiinntt
       The initial set of root nameservers is specified using a hhiinntt zone.
       When the server starts up, it uses the root hints to find a root name-
       server and get the most recent list of root nameservers.


     Note: previous releases of BIND used the term pprriimmaarryy for a master zone,
     sseeccoonnddaarryy for a slave zone, and ccaacchhee for a hint zone.


   CCllaasssseess

     The zone's name may optionally be followed by a class.  If a class is not
     specified, class iinn (for "internet"), is assumed.  This is correct for
     the vast majority of cases.


     The hheessiioodd class is for an information service from MIT's Project Athena.
     It is used to share information about various systems databases, such as
     users, groups, printers and so on.  More information can be found at
     ftp://athena-dist.mit.edu/pub/ATHENA/usenix/athena_changes.PS.  The key-
     word hhss is a synonym for hheessiioodd.


     Another MIT development was CHAOSnet, a LAN protocol created in the
     mid-1970s.  It is still sometimes seen on LISP stations and other hard-
     ware in the AI community, and zone data for it can be specified with the
     cchhaaooss class.


   OOppttiioonnss


     cchheecckk--nnaammeess
       See the subsection on _N_a_m_e _C_h_e_c_k_i_n_g in _T_H_E _O_P_T_I_O_N_S _S_T_A_T_E_M_E_N_T.


     aallllooww--qquueerryy
       See the description of aallllooww--qquueerryy in the _A_c_c_e_s_s _C_o_n_t_r_o_l subsection of
       _T_H_E _O_P_T_I_O_N_S _S_T_A_T_E_M_E_N_T.


     aallllooww--uuppddaattee
       Specifies which hosts are allowed to submit Dynamic DNS updates to the
       server.  The default is to deny updates from all hosts.


     aallllooww--ttrraannssffeerr
       See the description of aallllooww--ttrraannssffeerr in the _A_c_c_e_s_s _C_o_n_t_r_o_l subsection
       of _T_H_E _O_P_T_I_O_N_S _S_T_A_T_E_M_E_N_T.


     ttrraannssffeerr--ssoouurrccee
       ttrraannssffeerr--ssoouurrccee determines which local address will be bound to the TCP
       connection used to fetch this zone.  If not set, it defaults to a sys-
       tem controlled value which will usually be the address of the interface
       ``closest to'' the remote end.  This address must appear in the remote
       end's aallllooww--ttrraannssffeerr option for this zone if one is specified.


     mmaaxx--ttrraannssffeerr--ttiimmee--iinn
       See the description of mmaaxx--ttrraannssffeerr--ttiimmee--iinn in the _Z_o_n_e _T_r_a_n_s_f_e_r_s sub-
       section of _T_H_E _O_P_T_I_O_N_S _S_T_A_T_E_M_E_N_T.


     ddiiaalluupp
       See the description of ddiiaalluupp in the _B_o_o_l_e_a_n _O_p_t_i_o_n_s subsection of _T_H_E
       _O_P_T_I_O_N_S _S_T_A_T_E_M_E_N_T.


     nnoottiiffyy
       See the description of _n_o_t_i_f_y in the _B_o_o_l_e_a_n _O_p_t_i_o_n_s subsection of the
       _T_H_E _O_P_T_I_O_N_S _S_T_A_T_E_M_E_N_T.


     aallssoo--nnoottiiffyy
       aallssoo--nnoottiiffyy is only meaningful if nnoottiiffyy is active for this zone.  The
       set of machines that will receive a DNS NOTIFY message for this zone is
       made up of all the listed nameservers for the zone (other than the pri-
       mary master) plus any IP addresses specified with aallssoo--nnoottiiffyy. aallssoo--
       nnoottiiffyy is not meaningful for ssttuubb zones.  The default is the empty
       list.


     ffoorrwwaarrdd
       ffoorrwwaarrdd is only meaningful if the zone has a ffoorrwwaarrddeerrss list. The oonnllyy
       value causes the lookup to fail after trying the ffoorrwwaarrddeerrss and getting
       no answer, while ffiirrsstt would allow a normal lookup to be tried.


     ffoorrwwaarrddeerrss
       The ffoorrwwaarrddeerrss option in a zone is used to override the list of global
       forwarders.  If it is not specified in a zone of type ffoorrwwaarrdd, _n_o for-
       warding is done for the zone; the global options are not used.


     ppuubbkkeeyy
       The DNSSEC flags, protocol, and algorithm are specified, as well as a
       base-64 encoded string representing the key.


TTHHEE AACCLL SSTTAATTEEMMEENNTT
   SSyynnttaaxx


     acl _n_a_m_e {
       _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t
     };


   DDeeffiinniittiioonn aanndd UUssaaggee

     The aaccll statement creates a named address match list.  It gets its name
     from a primary use of address match lists:  Access Control Lists (ACLs).


     Note that an address match list's name must be defined with aaccll before it
     can be used elsewhere; no forward references are allowed.


     The following ACLs are built-in:



     aannyy
       Allows all hosts.

     nnoonnee
       Denies all hosts.

     llooccaallhhoosstt
       Allows the IP addresses of all interfaces on the system.

     llooccaallnneettss
       Allows any host on a network for which the system has an interface.


TTHHEE KKEEYY SSTTAATTEEMMEENNTT
   SSyynnttaaxx


     key _k_e_y___i_d {
       algorithm _a_l_g_o_r_i_t_h_m___i_d;
       secret _s_e_c_r_e_t___s_t_r_i_n_g;
     };


   DDeeffiinniittiioonn aanndd UUssaaggee

     The kkeeyy statement defines a key ID which can be used in a sseerrvveerr state-
     ment to associate a method of authentication with a particular name serv-
     er that is more rigorous than simple IP address matching.  A key ID must
     be created with the kkeeyy statement before it can be used in a sseerrvveerr defi-
     nition or an address match list.


     The _a_l_g_o_r_i_t_h_m___i_d is a string that specifies a security/authentication al-
     gorithm.  _s_e_c_r_e_t___s_t_r_i_n_g is the secret to be used by the algorithm, and is
     treated as a base-64 encoded string.  It should go without saying, but
     probably can't, that if you have _s_e_c_r_e_t___s_t_r_i_n_g _'_s in your _n_a_m_e_d_._c_o_n_f,
     then it should not be readable by anyone but the superuser.


TTHHEE TTRRUUSSTTEEDD--KKEEYYSS SSTTAATTEEMMEENNTT
   SSyynnttaaxx


     trusted-keys {
       [ _d_o_m_a_i_n___n_a_m_e _f_l_a_g_s _p_r_o_t_o_c_o_l _a_l_g_o_r_i_t_h_m _k_e_y; ]
     };


   DDeeffiinniittiioonn aanndd UUssaaggee

     The ttrruusstteedd--kkeeyyss statement is for use with DNSSEC-style security, origi-
     nally specified in RFC 2065.  DNSSEC is meant to provide three distinct
     services: key distribution, data origin authentication, and transaction
     and request authentication.  A complete description of DNSSEC and its use
     is beyond the scope of this document, and readers interested in more in-
     formation should start with RFC 2065 and then continue with the Internet
     Drafts available at http://www.ietf.org/ids.by.wg/dnssec.html.


     Each trusted key is associated with a domain name.  Its attributes are
     the non-negative integral _f_l_a_g_s, _p_r_o_t_o_c_o_l, and _a_l_g_o_r_i_t_h_m, as well as a
     base-64 encoded string representing the _k_e_y.



     Any number of trusted keys can be specified.


TTHHEE SSEERRVVEERR SSTTAATTEEMMEENNTT
   SSyynnttaaxx


     server _i_p___a_d_d_r {
       [ bogus _y_e_s___o_r___n_o; ]
       [ transfers _n_u_m_b_e_r; ]
       [ transfer-format ( one-answer | many-answers ); ]
       [ keys { _k_e_y___i_d [ _k_e_y___i_d ... ] }; ]
     };


   DDeeffiinniittiioonn aanndd UUssaaggee

     The server statement defines the characteristics to be associated with a
     remote name server.


     If you discover that a server is giving out bad data, marking it as bboogguuss
     will prevent further queries to it.  The default value of bboogguuss is no.
     Marking a server as bboogguuss will mark all other addresses for that server
     as bboogguuss when a match is made when looking up a server's address by name.


     The server supports two zone transfer methods.  The first, oonnee--aannsswweerr,
     uses one DNS message per resource record transferred.  mmaannyy--aannsswweerrss packs
     as many resource records as possible into a message.  mmaannyy--aannsswweerrss is
     more efficient, but is only known to be understood by BIND 8.1 and
     patched versions of BIND 4.9.5.  You can specify which method to use for
     a server with the ttrraannssffeerr--ffoorrmmaatt option.  If ttrraannssffeerr--ffoorrmmaatt is not
     specified, the ttrraannssffeerr--ffoorrmmaatt specified by the ooppttiioonnss statement will be
     used.


     The ttrraannssffeerrss will be used in a future release of the server to limit the
     number of concurrent in-bound zone transfers from the specified server.
     It is checked for syntax but is otherwise ignored.


     The kkeeyyss clause is used to identify a _k_e_y___i_d defined by the kkeeyy state-
     ment, to be used for transaction security when talking to the remote
     server.  The kkeeyy statememnt must come before the sseerrvveerr statement that
     references it.


     The kkeeyyss statement is intended for future use by the server.  It is
     checked for syntax but is otherwise ignored.


TTHHEE CCOONNTTRROOLLSS SSTTAATTEEMMEENNTT
   SSyynnttaaxx


     controls {
       [ inet _i_p___a_d_d_r
         port _i_p___p_o_r_t
         allow { _a_d_d_r_e_s_s___m_a_t_c_h___l_i_s_t; }; ]
       [ unix _p_a_t_h___n_a_m_e
         perm _n_u_m_b_e_r
         owner _n_u_m_b_e_r
         group _n_u_m_b_e_r; ]
     };


   DDeeffiinniittiioonn aanndd UUssaaggee

     The ccoonnttrroollss statement declares control channels to be used by system ad-
     ministrators to affect the operation of the local name server.  These
     control channels are used by the nnddcc utility to send commands to and re-
     trieve non-DNS results from a name server.


     A uunniixx control channel is a FIFO in the file system, and access to it is
     controlled by normal file system permissions.  It is created by nnaammeedd
     with the specified file mode bits (see chmod(1)),  user and group owner.
     Note that, unlike cchhmmoodd, the mode bits specified for ppeerrmm will normally
     have a leading 0 so the number is interpreted as octal.  Also note that
     the user and group ownership specified as oowwnneerr and ggrroouupp must be given
     as numbers, not names.  It is recommended that the permissions be re-
     stricted to administrative personnel only, or else any user on the system
     might be able to manage the local name server.


     An iinneett control channel is a TCP/IP socket accessible to the Internet,
     created at the specified _i_p___p_o_r_t on the specified _i_p___a_d_d_r. Modern tteellnneett
     clients are capable of speaking directly to these sockets, and the con-
     trol protocol is ARPAnet-style text.  It is recommended that 127.0.0.1 be
     the only _i_p___a_d_d_r used, and this only if you trust all non-privileged
     users on the local host to manage your name server.


TTHHEE IINNCCLLUUDDEE SSTTAATTEEMMEENNTT
   SSyynnttaaxx


     include _p_a_t_h___n_a_m_e;


   DDeeffiinniittiioonn aanndd UUssaaggee

     The iinncclluuddee statement inserts the specified file at the point that the
     iinncclluuddee statement is encountered.  It cannot be used within another
     statement, though, so a line such as
           acl internal_hosts { include internal_hosts.acl; };
     is not allowed.


     Use iinncclluuddee to break the configuration up into easily-managed chunks.
     For example:


     include "/etc/security/keys.bind";
     include "/etc/acls.bind";

     could be used at the top of a BIND configuration file in order to include
     any ACL or key information.


     Be careful not to type ``#include'', like you would in a C program, be-
     cause ``#'' is used to start a comment.


EEXXAAMMPPLLEESS
     The simplest configuration file that is still realistically useful is one
     which simply defines a hint zone that has a full path to the root servers
     file.

     zone "." in {
             type hint;
             file "/var/named/root.cache";
     };

     Here's a more typical real-world example.


     /*
      * A simple BIND 8 configuration
      */

     logging {
             category lame-servers { null; };
             category cname { null; };
     };

     options {
             directory "/var/named";
     };

     controls {
             inet * port 52 allow { any; };                  // a bad idea
             unix "/var/run/ndc" perm 0600 owner 0 group 0;  // the default
     };

     zone "isc.org" in {
             type master;
             file "master/isc.org";
     };

     zone "vix.com" in {
             type slave;
             file "slave/vix.com";
             masters { 10.0.0.53; };
     };

     zone "0.0.127.in-addr.arpa" in {
             type master;
             file "master/127.0.0";
     };

     zone "." in {
             type hint;
             file "root.cache";
     };


FFIILLEESS
     /etc/named.conf
       The BIND 8 nnaammeedd configuration file.


SSEEEE AALLSSOO
     named(8),  ndc(8)

4th Berkeley Distribution       January 7, 1999                             28
